#Author Christophe Robert : christof.robert@wanadoo.fr
#Release 0.0.1   24/03/2002
#
#
# Client Functions for Xindice XML Server - www.dbxml.org
# Contains functions for administering and accessing the server
# via XML-RPC



from xmlrpclib import Server
import xml.sax
import cStringIO


#
#	Class Result_Key // SAX
#

class Result_Key(xml.sax.ContentHandler):
	def __init__(self, mark = 'person'):
#		self.CurrentData=""
		self.key=[]
		self.mark = mark

	def startElement(self,tag,attrs):
		if tag != self.mark : return  
		
		self.key.append(str(attrs.get('src:key', None)))
		
#
#	Main Class for Xindice/XML-RPC
#


class Xindice:
	"""    Class Indice for XML Base """

	def __init__(self, server = '127.0.0.1' , port ='4080' , collection = '/db/addressbook'):
		self.server = server
		self.port   = port
		self.collection = collection
		self.param = "http://" + server + ":" + port
		self.conx = Server(self.param)
		self.rt = 'false' 

#
# returns a list of collections from the server
#

	def listCollections(self):
		""" list a Collection """
		try:
			return self.conx.db.listCollections(self.collection)
		except:
			return self.rt 

        def removeCollections(self, col):
		""" remove a collection """
		try:
			return self.conx.db.dropCollection(col)
		except:
			return self.rt 

        def createCollections(self,col):
		""" create a collection """
		try:
			return self.conx.db.createCollection(self.collection,col)
		except:
			return self.rt

#		
# returns a list of indexers
#

	def listIndexer(self):
		""" list indexer """
		try:
			return self.conx.db.listIndexers(self.collection)
		except:
			return self.rt 

        def removeIndexer(self, mark):
		""" remove indexer """
		try:
			return self.conx.db.dropIndexer(self.collection, mark)
		except:
			return self.rt 

        def createIndexer(self, mark, indexe):
		""" list indexer """
		try:
			return self.conx.db.createIndexer(self.collection, mark, indexe)
		except:
			return self.rt

#
# returns a list of documents from the server
#

        def listDocuments(self):
		""" list Documents """
		try:
			return self.conx.db.listDocuments(self.collection)
		except:
			return self.rt 

#
# returns document count from specified collection
#

        def countDocuments(self):
		""" count documents """
		try:
			return self.conx.db.getDocumentCount(self.collection)
		except:
			return self.rt 

#
# return an XML document from the server
#


        def openDocument(self, key ):
		""" return an XML document """
		try:
			return self.conx.db.getDocument(self.collection, key)
		except:
			return self.rt 
#
# returns  
#


#        def setDocument(self, key, content):
#		""" set Document """
#		try:
#			return self.conx.db.setDocument(self.collection, key, content)
#		except:
#			return self.rt 

        def insertDocument(self, key, content):
		""" insert document """
		try:
			return self.conx.db.insertDocument(self.collection, key, content)
		except:
			return self.rt 

        def deleteDocument(self, key ):
		""" delete document """
		try:
			return self.conx.db.removeDocument(self.collection, key)
		except:
			return self.rt 

#
# return XPath query 
#


        def queryCollection(self, type, query):
		""" query Collection """
		hash = {}
		try:
			return self.conx.db.queryCollection(self.collection, type, query, hash)
		except:
			return self.rt 
			

	def queryDocument(self, type, query, key ):
		""" query document """
		hash = {}
		try:
			return self.conx.db.queryDocument(self.collection, type, query, hash, key)
		except:
			return self.rt 


        def queryCollection_key(self, type, query, mark):
		""" query Collection """
		hash = {}
		try:
			flux_xml =  self.conx.db.queryCollection(self.collection, type, query, hash)
			Mparser = xml.sax.make_parser()
			Mparser.setFeature(xml.sax.handler.feature_namespaces, 0)
			Handler = Result_Key(mark)
			Mparser.setContentHandler(Handler)
			StringFile = cStringIO.StringIO(flux_xml)
			Source = xml.sax.InputSource("1")
			Source.setByteStream(StringFile)
			Mparser.parse(Source)

			return Handler.key  
		except:
			return self.rt

