# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '1.0'

from Globals import HTML,HTMLFile,MessageDialog
from ImageFile import ImageFile  
import Globals, sys, traceback
from OFS.DTMLDocument import DTMLDocument
from AccessControl import getSecurityManager


from Acquisition import Implicit
import os,stat,string,posixfile
import sys, traceback, tempfile

from xml.xslt.Processor import Processor
#from gnosis.xml.objectify import XML_Objectify, pyobj_printer

manage_add_item_Form = HTMLFile('dtml/add_item_form', globals())



def manage_add_item(self, id='',title='', file='' , REQUEST=None, submit=None):
    """Add a Xindice Item """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_doc_form',)
    #create new object instance
    id=str(id)
    title=str(title)
    ob=XindiceItem(file, __name__=id)
    ob.title=title
    ob.file = file
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'



class XindiceItem(DTMLDocument, Implicit):
    """ Zope Product object."""    

    meta_type = 'Xindice Item'
    icon = 'misc_/XindiceItem/docicon'     

    manage_opt = HTMLFile('dtml/manage_doc_options', globals())


    _properties=(
{'id':'title', 'type':'string','mode':'w'},
)



    def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	index_html
	"""
	data =  self.view_text(self.server,self.collection,self.query)
	
	res = self.standard_html_header(self, REQUEST)

	xsltproc = Processor()
	xsltproc.appendStylesheetString(self.file)

	res = res + xsltproc.runString(data)
	res = res + self.standard_html_footer(self, REQUEST)

	return res

    def feuille(self):
	"""
	feuille 
	"""
	return self.file

    def view_feuille(self, client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	view feuille
	"""
	return self.feuille()

    def view_result_query(self, client=None, REQUEST={}, RESPONSE=None, **kw):
	"""

	"""
	return self.view_text(self.server,self.collection,self.query)


    def xslt(self, xpath, client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	transformation xslt
	"""
	self.query = xpath
	data =  self.view_text(self.server,self.collection,self.query)

	res = self.standard_html_header(self, REQUEST)


	xsltproc = Processor()
	xsltproc.appendStylesheetString(self.file)

	res = res + xsltproc.runString(data)
	res = res + self.standard_html_footer(self, REQUEST)

	return res

    def xml2object(self, xpath, client=None, REQUEST={}, RESPONSE=None, **kw ):
	"""
	xml to object
	"""
	pass
#	self.query = xpath
#	data =  self.view_text(self.server,self.collection,self.query)

#	self.tmpdir = tempfile.mktemp()
#	os.mkdir('%s' % self.tmpdir)

#	fd = open("%s/%s" % (self.tmpdir, self.id), "w")
#	fd.write(data)
#	fd.close()

#	xml_object = XML_Objectify("%s/%s" % (self.tmpdir, self.id))

#	for fn in os.listdir("%s" % self.tmpdir):
#		os.remove("%s/%s" % (self.tmpdir, fn))
#	os.rmdir("%s" % self.tmpdir)

#	py_obj = xml_object.make_instance()

#	return py_obj


    def manage_edit(self,data,title, SUBMIT='Change',dtpref_cols='50',
                        dtpref_rows='20',REQUEST=None):
        """
        Replaces a Xindice Item contents with Data, Title with Title.  
        """
        
        self.file = data
	self._p_changed =  1
	ret = DTMLDocument.manage_edit(self,data,title,SUBMIT,dtpref_cols,dtpref_rows,REQUEST)
	return ret
#	u=REQUEST['URL1']
#	REQUEST.RESPONSE.redirect(u+'/manage_main')



Globals.default__class_init__(XindiceItem)


