# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================
__version__= '0.0.2'


from Globals import HTMLFile,MessageDialog
from ImageFile import ImageFile
from XindiceDocument import XindiceDocument,manage_add_doc_Form,manage_add_doc
from XindiceItem import XindiceItem,manage_add_item_Form,manage_add_item


# Load images from disk and make them accessible
misc_={
    'docicon':    ImageFile('img/documenticon.gif',globals()),
      }  





def initialize(context): 
    """Initialize the product."""
    

    try: 
        context.registerClass(
            XindiceDocument,
            constructors = (                 
                manage_add_doc_Form, 
                manage_add_doc),
            icon = 'img/documenticon.gif',
            )
        context.registerBaseClass(XindiceDocument)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb


    try:
        context.registerClass(
            XindiceItem,
            constructors = (
                manage_add_item_Form,
                manage_add_item),
            icon = 'img/documenticon.gif',
            )
        context.registerBaseClass(XindiceItem)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb
	
